django_mldl/site_2/polls/urls.py
from django.urls import path
from . import views

app_name = 'polls'

urlpatterns = [
    # 127.0.0.1:8000/polls/" 이후의 URL 은 polls/urls.py 가 handling 하도록 만들 예정입니다
    path('', views.index, name='index'), # '127.0.0.1:8000/polls/' 를 받아내도록 만들어줄 것입니다

    # 127.0.0.1:8000/polls/3
    path('<int:question_id>/', views.detail, name='detail'),

    # 127.0.0.1:8000/polls/3/results
    path('<int:question_id>/results/', views.results, name='results'),

    # 127.0.0.1:8000/polls/3/vote
    path('<int:question_id>/vote/', views.vote, name='vote'),
]

django_mldl/site_2/site_2/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('polls/', include('polls.urls'))
]

django_mldl/site_2/polls/models.py
from django.db import models
from django.utils import timezone
import datetime

# Create your models here.
class Question(models.Model): # DB Table for 설문조사 주제
    question_text = models.CharField(max_length=200) # 설문조사 주제 텍스트
    pub_date = models.DateTimeField('date published') # ‘date published’ : 관리자 페이지에서 보여질 항목명

    def __str__(self): # Admin page 에서 display 되는 텍스트에 대한 변경
        return self.question_text

    def was_published_recently(self):
        now = timezone.now()
        return now >= self.pub_date >= now - datetime.timedelta(days=1)

    # 관리자 페이지 Question 리스트에서 True/False 문구를 아이콘으로 변경
    was_published_recently.boolean = True

    # 'WAS PUBLISHED RECENTLY' 열의 정렬 기준을 pub_date( 설문조사 주제 생성 시간 로 세팅
    was_published_recently.admin_order_field = 'pub_date'

    # 'WAS PUBLISHED RECENTLY' 열의 이름 변경
    was_published_recently.short_description = 'Published recently?'
    
class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE) # 설문조사 주제의 id 값
    choice_text = models.CharField(max_length=200) # 설문조사 주제에 대한 선택지 텍스트
    votes = models.IntegerField(default=0) # 해당 선택지의 득표 수

    def __str__(self): # Admin page 에서 display 되는 텍스트에 대한 변경
        return self.choice_text

django_mldl/site_2/polls/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponse, Http404
from .models import Question

# Create your views here.
def index(request):
    # order_ pub_date')[:5] : 등록 날짜 기준 내림차순 정렬 후 앞에서 5 개까지만
    latest_question_list = Question.objects.order_by('-pub_date')[:5] # '-': 역순

    # 지난 실습에서 render() 함수의 {~:~} 로 html 파일에게 넘겨주던 dict 를 context 라고 부릅니다
    context = {'latest_question_list': latest_question_list}

    return render(request, 'polls/index.html', context)

def detail(request, question_id):
    '''
    # method 1
    try:
        q = Question.objects.get(pk= question_id)
    except Question.DoesNotExist:
        raise Http404('Question {} does not exist'.format( question_id ))
    '''

    # method 2
    # list Q uerySet) 가 return 될 시에는 get_object_or_404 대신 get_list_or_404 를 활용
    q = get_object_or_404(Question, pk=question_id)
    return render(request, 'polls/detail.html', {'question': q})

def results(request, question_id):
    question = get_object_or_404(Question, pk=question_id) # get_list_or_404 여러개의 리스트를 뽑을 때
    return render(request, 'polls/result.html', {'question': question})

def vote(request, question_id):

    question = get_object_or_404(Question, pk=question_id)
    # print('*******************{}***********'.format(request.POST))
    try:
        selected_choice = question.choice_set.get(pk=request.POST['choice_select'])

    except:
        context = {'question': question, 'error_message': "You didn't select a choice."}

        return render(request, 'polls/detail.html', context)

    else:
        selected_choice.votes += 1
        selected_choice.save()
        return redirect('polls:results', question_id = question.id)

django_mldl/site_2/polls/templates/polls/base.html
{% load static %}

<!DOCTYPE html>
<html lang="ko">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Django Polls (version 1.0)</title>
  <link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
  <link href="//fonts.googleapis.com/css?family=Do+Hyeon|Noto+Sans&display=swap" rel="stylesheet">
  <link rel="stylesheet" type="text/css" href="{% static 'polls/style.css' %}" />
</head>
<body>
  <div class="container">
    <nav class="navbar navbar-default">
      <div class="container-fluid">
        <div class="navbar-header">
          <span class="navbar-brand">Django Polls (version 1.0)</span>
        </div>
        <ul class="nav navbar-nav">
          <li><a href = "{% url 'polls:index' %}">Voting</a></li>
          <li class="navbar-right"><a href = "{% url 'admin:index' %}">Administrator</a></li>
        </ul>
      </div>
    </nav>
    <div>
      {% block content %}
      {% endblock %}
    </div>
  </div>
  <footer class="footer">
    <div class="container">
      <p class="text-muted">Copyright ⓒ 2020 Replus | Django Polls | All Rights Reserved</p>
    </div>
  </footer>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
</body>
</html>

django_mldl/site_2/polls/templates/polls/detail.html
{% extends 'polls/base.html' %}

{% block content %}

<h2>{{ question.question_text}}</h2>

{% if error_message %}
  <p><strong>{{ error_message }}</strong></p>
{% endif %}

<!-- <form action="/polls/{{ question.id }}/vote/" method="post"> 아래 줄과 같은 코드-->
<form action="{% url 'polls:vote' question.id %}" method="post">
    {% csrf_token %}
    {% for choice in question.choice_set.all %}
      <input type="radio" name="choice_select" id="choice{{ forloop.counter }}" value="{{ choice.id }}">
      <label for="choice{{ forloop.counter }}" style="color: blue;">{{ choice.choice_text }}</label>
      <br>
    {% endfor %}
    <input type="submit" value="Vote">
</form>

{% endblock %}

django_mldl/site_2/polls/templates/polls/index.html
{% extends 'polls/base.html' %}

{% block content %}

{% if latest_question_list %}
  <ol>
    {% for question in latest_question_list %}
    <li>
      <a href="{% url 'polls:detail' question.id %}">{{ question.question_text }}</a>
      <!-- polls는 app_name -->
    </li>
    {% endfor %}
  </ol>
{% else %}
  <p>No polls are available.</p>
{% endif %}

{% endblock %}

django_mldl/site_2/polls/templates/polls/result.html
{% extends 'polls/base.html' %}

{% block content %}

<h1>{{ question.question_text }}</h1>

<ul>
  {% for choice in question.choice_set.all %}
  <li>{{ choice.choice_text }} got voted for {{ choice.votes }} times.</li>
  {% endfor %}
</ul>

<a href="{% url 'polls:detail' question.id %}">Vote again?</a>

{% endblock %}